﻿ #!/usr/bin/perl
 
my @rows;
my $lineProcessor;

open (PPM, "$ARGV[0]");
#my $ppmstring = join('', <PPM>);
$lineProcessor = "   ";
my @left_over_array = ();
my $colCount = 0;
my $done_colCount = 0;
my $row_counter = 1;
# go through each line of the file
while(<PPM>)
{
 # Good practice to store $_ value because
 # subsequent operations may change it.
	my($ppmstring) = $_;
 # remove the trailing whitespace	
	chomp($ppmstring);
# make sure it is a row we want	
	if($ppmstring =~ m/^\d+ \d+ \d+ \d+ \d+ \d+ \d+ \d+ \d+ \d+ \d+ \d+ \d+ \d+ \d+ \d+ \d+/ ){
		#surround the numbers in table cells
		$ppmstring =~ s/((\d+) *)/<td>\2<\/td>/g;
		$lineProcessor .= $ppmstring;
		# if we have not counted the columns yet add 17 to the column count
		if( ! $done_colCount){
			$colCount += 17;
		}
# it could also be a line with just numbers on it which is good too		
	}elsif( $ppmstring =~ m/^\d+ \d+ \d+/){
		#put each number into its own cell
		$ppmstring =~ s/((\d+) *)/<td>\2<\/td>/g;
		# finish off the line of html
		$lineProcessor .= $ppmstring . "</tr>\n";
		#push this line of the html table onto an array to be counted later.. maybe
		push(@rows, $lineProcessor);
		#finish counting the columns
		if( ! $done_colCount){
			#split the original line from the file by spaces to count it;
			@left_over_array = split " ", $_;
			$colCount += scalar(@left_over_array);
			$done_colCount = 1;
		}      
		$row_counter += 1;
		#make a new row of the table;
		$lineProcessor = "<tr><td>${row_counter}</td>";
	}
}
close (PPM);

$ppmstring = join("\n", @rows);

# make an array of the column count
my @colCountArray = (1 .. $colCount);
# make a row
my $topRow = "<tr><td></td>"; 
foreach my $topRowColumn (@colCountArray){
	$topRow .= sprintf '<td>%.2d</td>', $topRowColumn;
}
$topRow .= "</tr>";


print "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\"> <html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en' lang='en'><head><title>PixelPainting</title><style type='text/css'> table tr td {width:40px;height:40px;text-align:center; border:2px solid black;} table{border-collapse:collapse;}</style></head>\n<body>\n<h3>$ARGV[0]</h3>\n<table>\n$topRow\n<tr><td>1</td>$ppmstring</table></body></html>";
